--- bm_search.c	1998-09-20 12:49:08.000000000 -0400
+++ bm_search.c	2014-12-27 01:29:41.000000000 -0500
@@ -58,5 +58,5 @@
 #include <sys/types.h>
 #define const
-#include "regex.h"
+#include <gnu/regex.h>
 
 #include "main_text.h"
@@ -71,7 +71,7 @@
 #include "selection.h"
 
-static char *str_save = 0;
-static char *str_old = 0;
-static char *str_new = 0;
+static const char *str_save = NULL;
+static const char *str_old = NULL;
+static const char *str_new = NULL;
 static int abort_debug = False;
 
@@ -100,6 +100,6 @@ void ForwardSearch ( text )
 {
     char *str;
-    
-    if ( (str = (char *) SetString ( text, "Forward search : ", S_KBD )) == 0 )  {
+
+    if ( (str = SetString ( text, "Forward search : ", S_KBD )) == 0 )  {
 	DisplayMessage ( text -> mwin, "Abort" );
 	return;
@@ -107,10 +107,10 @@ void ForwardSearch ( text )
     else
       DisplayMessage ( text -> mwin, "Search..." );
-    
+
     if ( HandleForward ( str, text ) == 0 ) {
 	DisplayMessage ( text -> mwin, "Search failed" );
 	klaxon ();
     }
-    
+
 }
 
@@ -124,14 +124,14 @@ void ForwardSearch ( text )
 **	Ouput :
 */
-int HandleForward ( str, text )	
+int HandleForward ( str, text )
     char *str;
     Text *text;
-{	
+{
     int newpos;
     char *start,  *end;
-    
-    start = (char *) RightBuf ( text -> buf ); 
+
+    start = (char *) RightBuf ( text -> buf );
     end = (char *) BottomBuf ( text -> buf );
-    
+
     if ( (newpos=BmSearch( start, str,  end -start, FORWARD )) != -1 ) {
 	if ( newpos == 0 ) { 	/* On est pile dessus */
@@ -162,5 +162,5 @@ void BackwardSearch ( text )
 {
     char *str;
-    
+
     if ( (str = (char *) SetString ( text, "Backward search : ", S_KBD )) == 0 ) {
 	DisplayMessage ( text -> mwin, "Abort" );
@@ -168,6 +168,6 @@ void BackwardSearch ( text )
     }
     else
-      DisplayMessage ( text -> mwin, "Search..." );	
-    
+      DisplayMessage ( text -> mwin, "Search..." );
+
     if ( HandleBackward ( str, text ) == 0 ) {
 	DisplayMessage ( text -> mwin, "Search failed" );
@@ -192,9 +192,9 @@ int HandleBackward ( str, text )
     char *start,  *end;
     int len;
-    
+
     oldpos = GetNcFromRight ( text -> buf );
     start = (char *) GetCurrentLine ( text -> buf, &len );
     end = (char *) TopBuf ( text -> buf );
-    
+
     start += ( len -1);	/* On part de la fin de la ligne */
     if ( (newpos=BmSearch( start, str, len-1, BACKWARD )) != -1 ) {
@@ -232,10 +232,10 @@ void GlobalReplace ( text )
 **	Function name : SetPatterns
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 void SetPatterns ( old, new )
-    char *old, *new;
+    const char *old, *new;
 {
     str_old = old;
@@ -246,12 +246,12 @@ void SetPatterns ( old, new )
 **	Function name : ResetPatterns
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 void ResetPatterns ()
 {
-    str_old = 0;
-    str_new = 0;
+    str_old = NULL;
+    str_new = NULL;
 }
 
@@ -270,5 +270,5 @@ int HandleGlobal ( text )
     char *start,  *end;
     int f_query = False;
-    
+
     if (text -> selection -> select == True) {
       SetCurrentLine (text);
@@ -278,11 +278,11 @@ int HandleGlobal ( text )
     line = text -> no_current_line;
     old_pos = GetNcFromLeft ( text -> buf );
-    
+
     start = (char *) RightBuf ( text -> buf );
     end = (char *) BottomBuf ( text -> buf );
-    
+
     i = 0;
     StorePosition(text);
-    
+
     if ( (newpos=BmSearch( start, str_new,  end - start, FORWARD )) != -1 ) {
 	/*
@@ -292,5 +292,5 @@ int HandleGlobal ( text )
 	DisplayMessage ( text -> mwin, "done, but warning : query ..." );
 	while ( (newpos=BmSearch( start, str_old,  end -start, FORWARD )) != -1 ) {
-	    GotoPos ( text, start, newpos, FORWARD ); 
+	    GotoPos ( text, start, newpos, FORWARD );
 	    (void) MoveHole ( text -> buf, strlen (str_old)); /* On se place a la fin du mot */
 	    StoreInUndo ( text, str_old, str_new, 1 ,0 , U_REP );
@@ -303,5 +303,5 @@ int HandleGlobal ( text )
 	    InsertNchar ( text -> buf, str_new, strlen ( str_new));
 	    modif = True;
-	    start = (char *) RightBuf ( text -> buf ); 
+	    start = (char *) RightBuf ( text -> buf );
 	    end = (char *) BottomBuf ( text -> buf );
 	    i++;
@@ -324,5 +324,5 @@ int HandleGlobal ( text )
 	}
     }
-    ResetMark ( text );	
+    ResetMark ( text );
     HoleToLeft ( text -> buf );
     text -> no_current_line = 1;
@@ -331,5 +331,5 @@ int HandleGlobal ( text )
     SetPosition(text);
     UpdatePage(text);
-    
+
     if ( modif == True )
       SetTextModif ( text );
@@ -354,5 +354,5 @@ void QueryReplace ( text )
     int abort, modif;
     char c = '\007'; /* ^G */
-    
+
     if (text -> selection -> select == True){
       SetCurrentLine (text);
@@ -361,17 +361,17 @@ void QueryReplace ( text )
 
     if ( SetReplaceString ( text, QUERY, S_KBD ) == -1 ) return;
-    
-    start = (char *) RightBuf ( text -> buf ); 
+
+    start = (char *) RightBuf ( text -> buf );
     end = (char *) BottomBuf ( text -> buf );
-    
+
     modif = abort = False;
-    
+
     while ( (newpos=BmSearch( start, str_old,  end -start, FORWARD )) != -1 ) {
-	GotoPos ( text, start, newpos, FORWARD ); 
+	GotoPos ( text, start, newpos, FORWARD );
 	SetAndDisplayPage ( text );
 	TextCursorOn ( text );
 	(void) MoveHole ( text -> buf, strlen (str_old)); /* On se place a la fin du mot */
 	reply = (char * ) GetString ( text, "Replace [y,n,q] : ", 1 );
-	
+
 	if ( (reply == 0) || (strncmp(reply, &c, 1)) == 0 || (strncmp(reply, "q", 1) == 0 )) {
 	    abort = True;
@@ -391,15 +391,15 @@ void QueryReplace ( text )
 	    modif = True;
 	}
-	start = (char *) RightBuf ( text -> buf ); 
+	start = (char *) RightBuf ( text -> buf );
 	end = (char *) BottomBuf ( text -> buf );
     }
-    
+
     if ( abort == True )
       DisplayMessage ( text -> mwin, "Abort" );
     else
       DisplayMessage ( text -> mwin, "Done" );
-    
+
     /* On revient au debut du mot */
-    
+
     SetAndDisplayPage ( text );
     if ( modif == True )
@@ -421,5 +421,5 @@ void MenuForwardSearch ( text )
 {
     char *str;
-    
+
     (void) ResetSearchString ();
     if ( (str = (char *) SetString ( text, "Forward search : ", S_MENU )) == 0 )  {
@@ -448,5 +448,5 @@ void MenuBackwardSearch ( text )
 {
     char *str;
-    
+
     (void) ResetSearchString ();
     if ( (str = (char *) SetString ( text, "Backward search : ", S_MENU )) == 0 )  {
@@ -508,6 +508,6 @@ void MenuGlobalReplace ( text )
 */
 int BmSearch ( buf, str, buf_len, dir )
-    char *buf;	/* Le buffer */
-    char *str;	/* La string */
+    const char *buf;	/* Le buffer */
+    const char *str;	/* La string */
     int buf_len;	/* Longueur du buffer */
     int dir;	/* Forward (1), Backward (-1)*/
@@ -517,25 +517,25 @@ int BmSearch ( buf, str, buf_len, dir )
     int i, j, k, t;
     int index [256];
- 
+
     if((buf_len +1)< s_len) {
       return -1;
     }
-    for ( i = 0 ; i < 256 ; i++ )  index [i] = s_len;	
-    
+    for ( i = 0 ; i < 256 ; i++ )  index [i] = s_len;
+
     for ( i = 0; i < s_len; i++ ) {
 	k = ( dir == FORWARD ) ? len - i : i;
-	if ( index [(int) str [k]] == s_len ) 
+	if ( index [(int) str [k]] == s_len )
 	  index [(int) str [k]] = i;
     }
 #ifdef DEBUG
-    for ( i = 0 ; i < 256 ; i++ ) 
+    for ( i = 0 ; i < 256 ; i++ )
       if ( index[i] != s_len )
 	fprintf ( stderr, "index %c %d = %d\n", i, index [i],  (char) i);
 #endif
-    for ( i = ( dir == FORWARD) ? len : 0, 
+    for ( i = ( dir == FORWARD) ? len : 0,
 	 j = ( dir == FORWARD) ? len : 0;
 	 (( dir == FORWARD) ? ( j>= 0) : (j <= len));
 	 i -= ( dir == FORWARD) ? FORWARD : BACKWARD,
-	 j -= ( dir == FORWARD) ? FORWARD : BACKWARD ) { 
+	 j -= ( dir == FORWARD) ? FORWARD : BACKWARD ) {
 #ifdef DEBUG
 	(void) fprintf ( stderr, "i = %d, j = %d\n", i, j );
@@ -545,5 +545,5 @@ int BmSearch ( buf, str, buf_len, dir )
 	    t = index [(unsigned char) buf [i] ];
 	    if ( dir == FORWARD ) {
-#ifdef DEBUG 
+#ifdef DEBUG
 		(void) fprintf ( stderr, "buf[%d] = %d str[%d] = %c t = %d\n",
 				i, (unsigned char) buf[i], j, str[j], t );
@@ -554,11 +554,11 @@ int BmSearch ( buf, str, buf_len, dir )
 	    }
 	    else {
-#ifdef DEBUG 
+#ifdef DEBUG
 		(void) fprintf ( stderr, "buf[%d] = %c str[%d] = %c t = %d\n", i, buf[i], j, str[j], t );
 #endif
-		i -= ( j > t) ? s_len : t; 
-		
+		i -= ( j > t) ? s_len : t;
+
 		if ( (buf_len +1 +i) < 0 ) return -1;
-		j = 0; 
+		j = 0;
 	    }
 	}
@@ -584,5 +584,5 @@ static char *SetString ( text, prompt, f
     char c = '\007'; /* ^G */
     int len;
-    
+
     if (text -> selection -> select == True) {
       SetCurrentLine (text);
@@ -593,7 +593,7 @@ static char *SetString ( text, prompt, f
 	if ( from == S_KBD )
 	  str = (char *) GetString ( text, prompt, False );
-	else 
+	else
 	  str = ( char *) GetStringFromDB ( prompt, False );
-	
+
 	if ( str == 0 )
 	  return 0;
@@ -629,9 +629,9 @@ static int SetReplaceString ( text, type
     char buf [64], tmp[64];
     int len;
-    
+
     if ( type == GLOBAL )
       (void) strcpy ( tmp, "Global replace," );
     else
-      (void) strcpy ( tmp, "Query replace," );	
+      (void) strcpy ( tmp, "Query replace," );
     (void) ResetSearchString ();
     (void) strcpy ( buf, tmp );
@@ -647,11 +647,11 @@ static int SetReplaceString ( text, type
     (void) strncpy ( str_old, str, len );
     *(str_old + len) = '\0';
-    
+
     (void) ResetSearchString ();
-    
+
     buf [0] = '\0';
     (void) strcpy ( buf, tmp );
     (void) strcat ( buf, " New String : " );
-    
+
     if ( (str = (char *) SetString ( text, buf, from )) == 0 ) {
 	if ( abort_debug == True ) {
@@ -665,5 +665,5 @@ static int SetReplaceString ( text, type
 	}
     }
-    
+
     len = strlen (str);
     if ( str_new != 0 )
@@ -699,6 +699,6 @@ static void GotoPos ( text, start, newpo
     line = GetNewLine ( start, x );
     text -> no_current_line += (dir == FORWARD ) ? line : -line;
-    
-    (void) MoveHole ( text -> buf, x );	
+
+    (void) MoveHole ( text -> buf, x );
     if ( line != 0 ) {
 	if ( (line > (( dir == FORWARD) ? text -> n2 : text -> n1 )))
@@ -706,5 +706,5 @@ static void GotoPos ( text, start, newpo
 	else {
 	    text -> n1 += (dir == FORWARD) ? line : -line;
-	    text -> n2 -= (dir == FORWARD) ? line : -line;				
+	    text -> n2 -= (dir == FORWARD) ? line : -line;
 	    SetAndDisplayPage ( text );
 	}
@@ -716,6 +716,6 @@ static void GotoPos ( text, start, newpo
 **	Function name : DeleteStrings
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
@@ -724,5 +724,5 @@ void DeleteStrings ()
     if ( str_save != 0 )
       (void) free ( str_save );
-    if ( str_old != 0 )   
+    if ( str_old != 0 )
       (void) free ( str_old );
     if ( str_new != 0 )
@@ -734,6 +734,6 @@ void DeleteStrings ()
 **	Function name : ResetSearchString
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
@@ -748,6 +748,6 @@ void ResetSearchString ()
 **	Function name : SearchInMan
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
@@ -756,5 +756,5 @@ void SearchInMan ( text )
 {
     char *str;
-    
+
     (void) ResetSearchString ();
     if ( (str = (char *) SetString ( text, "Manual Search : ", S_MENU )) == 0 )  {
@@ -762,5 +762,5 @@ void SearchInMan ( text )
 	return;
     }
-    
+
     if ( HandleForward ( str, text ) != 0 )
       return;
@@ -773,5 +773,5 @@ void SearchInMan ( text )
 /*===============
    REGEX SEARCH
-================*/   
+================*/
 /*
 **	Function name : UpddateRegs
@@ -781,5 +781,5 @@ void SearchInMan ( text )
 **         forward_search.
 **         Ceci pour avoir des positions SMAC correctes
-**         pour les re_sub_expressions.  
+**         pour les re_sub_expressions.
 **	Input : La position courante a ajouter.
 **	Output :
@@ -787,7 +787,7 @@ void SearchInMan ( text )
 void UpdateRegs (n)
 {
-    
+
     int i = RE_registers.num_regs;
-    
+
     for (i=0;i<RE_registers.num_regs;i++) {
 	RE_registers.start [i] += n;
@@ -801,10 +801,10 @@ void UpdateRegs (n)
 **	Function name : RE_Match
 **
-**	Description : 
+**	Description :
 **	Input : le numeron du registre (0 et 1 correspondent
 **         la premiere re_subexp. Un flag boleen pour le debut
 **         ou la fin de la re_subexp courante.
 **	Output : La position du debut ou de la fin de la re_subexp
-**         courante.  
+**         courante.
 */
 int RE_Match (n, beginning )
@@ -816,5 +816,5 @@ int RE_Match (n, beginning )
     return -1;
 
-  if (beginning) 
+  if (beginning)
     return (RE_registers.start[n]);
   else
@@ -834,5 +834,5 @@ void RE_MenuForwardSearch ( text )
     int newpos, orig;
     char *str;
-    
+
     (void) ResetSearchString ();
     if ( (str = (char *) SetString ( text, "Regex forward search : ", S_MENU )) == 0 )  {
@@ -847,5 +847,5 @@ void RE_MenuForwardSearch ( text )
 
     if ((newpos == -1) || (newpos == -2) ){
-      klaxon (); 
+      klaxon ();
       return;
     }
@@ -857,9 +857,9 @@ void RE_MenuForwardSearch ( text )
 	    if ((newpos == -1) || (newpos == -2) ){
 		(void) MoveHole ( text -> buf, -1 );
-		klaxon (); 
+		klaxon ();
 		return;
 	    }
 	}
-	(void) ie_goto_char (text, newpos);	
+	(void) ie_goto_char (text, newpos);
 	ie_redisplay (text);
     }
@@ -871,5 +871,5 @@ void RE_MenuForwardSearch ( text )
 **	Description : Recherche en arriere d'une regex.
 **         Si on est deja a l'interieur de la regex recherchee,
-**         celle-ci n'esp pas vue.  
+**         celle-ci n'esp pas vue.
 **	Input :
 **	Output :
@@ -880,5 +880,5 @@ void RE_MenuBackwardSearch ( text )
     int newpos;
     char *str;
-    
+
     (void) ResetSearchString ();
     if ( (str = (char *) SetString ( text, "Regex backward search : ", S_MENU )) == 0 )  {
@@ -892,5 +892,5 @@ void RE_MenuBackwardSearch ( text )
 
     if ((newpos == -1) || (newpos == -2) ){
-	klaxon (); 
+	klaxon ();
 	return;
     }
@@ -906,11 +906,11 @@ void RE_MenuBackwardSearch ( text )
 **	Description : Recherche d'une expression reguliere dans un buffer.
 **         On considere que les frontieres sont valides (buffer + ou - size)
-**	Input : L'expression reguliere, le buffer, la frontiere dans le 
+**	Input : L'expression reguliere, le buffer, la frontiere dans le
 **         buffer et la direction de recherche.
 **	Output : la position dans le buffer, -1 sinon et -2 si error (compile).
 */
 int RE_Search ( regex, buffer, size, direction)
-    char *regex;
-    char *buffer;
+    const char *regex;
+    const char *buffer;
     int size;
     int direction;
@@ -919,5 +919,5 @@ int RE_Search ( regex, buffer, size, dir
     static char *old_regex = 0;
     int search_result;
-    
+
     int start = (direction == FORWARD) ? 0 : size-1;
     int range = (direction == FORWARD) ? size-1 : -size+1;
@@ -925,5 +925,5 @@ int RE_Search ( regex, buffer, size, dir
     int start = (direction == FORWARD) ? 0 : size;
     int range = (direction == FORWARD) ? size : -size;
-*/    
+*/
     if ((old_regex == 0) || (strcmp (old_regex, regex) != 0)) {
 	/*
@@ -932,20 +932,19 @@ int RE_Search ( regex, buffer, size, dir
 	RE_pattern_buffer.fastmap = RE_fastmap;
 	compile_result = re_compile_pattern (regex, strlen (regex), &RE_pattern_buffer);
-	if (compile_result != (char *) 0)
+	if (compile_result != NULL)
 	  return (-2);
 
 	if (old_regex)
-	  (void) free(old_regex);
-	old_regex = (char*) malloc ((unsigned) strlen(regex) + 1);
-	strcpy (old_regex, regex);
+	  free(old_regex);
+	old_regex = strdup(regex);
     }
-   
+
 #ifdef DEBUG
     (void) fprintf ( stderr, "size = %d range = %d\n reg = %s len = %d\n",
 		    size, range, regex, strlen(regex));
 #endif /* DEBUG */
- 
+
     search_result = re_search ( &RE_pattern_buffer,
-			       buffer, size, start, range, &RE_registers ); 
+			       buffer, size, start, range, &RE_registers );
 
     return (search_result);
@@ -963,5 +962,5 @@ void RE_MenuReplace ( text )
 {
     if ( SetReplaceString ( text, QUERY, S_MENU ) == -1 ) return;
-    
+
     ie_re_replace ( text, str_old, str_new );
     ie_redisplay (text);
@@ -978,9 +977,9 @@ void RE_MenuReplace ( text )
 int RE_ReplaceMatch ( text, newstring )
     Text *text;
-    char *newstring;
+    const char *newstring;
 {
     int i,j,re_len, new_len = strlen(newstring);
     int nth_c, c;
-    
+
     char *buffer;
 
@@ -990,10 +989,10 @@ int RE_ReplaceMatch ( text, newstring )
     re_len = RE_registers.end[0] - RE_registers.start[0];
     */
-    
+
     /* newstring peut contenir \& ou \n avec 0<n<10.
        \& : substitution par la regex.
        \n : substitution par la substring n de la regex.
     */
-    
+
     /* MA:
     ** Since RE_registers.start/end measure from the top of the buffer
@@ -1003,5 +1002,5 @@ int RE_ReplaceMatch ( text, newstring )
     */
     ie_goto_char(text, RE_registers.start[0]);
-    
+
     buffer = RightBuf(text->buf); /* On est sur la regex */
     for (i=0;i<new_len;i++) {
@@ -1067,5 +1066,5 @@ int RE_ReplaceMatch ( text, newstring )
 	ie_delete_char (text);
     }
-    
+
     return (1);
 }
--- bm_search.h	1995-02-22 08:03:25.000000000 -0500
+++ bm_search.h	2014-12-26 01:27:26.000000000 -0500
@@ -52,10 +52,10 @@
 
 FCT (void, BackwardSearch, (Text *text) );
-FCT (int, BmSearch, (char *buf, char *str, int buf_len, int dir ) );
-FCT (void, DeleteStrings, () );
+FCT (int, BmSearch, (const char *buf, const char *str, int buf_len, int dir ) );
+FCT (void, DeleteStrings, (void) );
 FCT (void, ForwardSearch, (Text *text) );
 FCT (void, GlobalReplace, (Text *text) );
-FCT (int, HandleBackward, (char *str, Text *text) );
-FCT (int, HandleForward, (char *str, Text *text) );
+FCT (int, HandleBackward, (const char *str, Text *text) );
+FCT (int, HandleForward, (const char *str, Text *text) );
 FCT (int, HandleGlobal, (Text *text) );
 FCT (void, MenuBackwardSearch, (Text *text) );
@@ -64,13 +64,14 @@ FCT (void, MenuGlobalReplace, (Text *tex
 FCT (void, MenuQueryReplace, (Text *text) );
 FCT (void, QueryReplace, (Text *text) );
-FCT (void, ResetPatterns, () );
-FCT (void, ResetSearchString, () );
+FCT (void, ResetPatterns, (void) );
+FCT (void, ResetSearchString, (void) );
 FCT (void, SearchInMan, (Text *text) );
-FCT (void, SetPatterns, (char *old, char *new) );
+FCT (void, SetPatterns, (const char *old, const char *new) );
 FCT (void, RE_MenuForwardSearch, (Text *text) );
 FCT (void, RE_MenuBackwardSearch, (Text *text) );
 FCT (void, RE_MenuReplace, (Text *text) );
-FCT (int, RE_Search, (char* regex, char *buffer, int size, int direction) );
+FCT (int, RE_Search, (const char* regex, const char *buffer, int size, int direction) );
 FCT (int, RE_Match, (int n, int beginning ) );
+FCT (int, RE_ReplaceMatch, (Text *, const char *newstring) );
 FCT (void, UpdateRegs, (int n) );
 
